projectdir="C:/Projecten/Eva/"

inputdir=paste(projectdir,"Input/",sep="")


#sample1=read.table(file=paste(inputdir,"sample.csv",sep=""),header=TRUE,sep=";")
#head(sample1)
#sample1=sample1[,which(names(sample1) %in% c("id_sample","id_subject","matrix","samplingyear","samplingmonth","samplingday"))]
#head(sample1)
#subject1=read.table(file=paste(inputdir,"subjectUnique.csv",sep=""),header=TRUE,sep=";")
#head(subject1)
#subject1=subject1[,which(names(subject1) %in% c("id_subject","sex"))]
#head(subject1)
#subject2=read.table(file=paste(inputdir,"subjectRepeated.csv",sep=""),header=TRUE,sep=";")
#head(subject2)
#subject2=subject2[,which(names(subject2) %in% c("id_subject","country","ageyears","isced","smoking","height","weight","bmi"))]
#head(subject2)
#dataUM=read.table(file=paste(inputdir,"dataUM.csv",sep=""),header=TRUE,sep=";")
#head(dataUM)
#names(dataUM)[which(names(dataUM)=="mehp")]="urinary_biomerker"
#names(dataUM)[which(names(dataUM)=="mehp_lod")]="urinary_biomerker_lod"
#names(dataUM)[which(names(dataUM)=="mehp_loq")]="urinary_biomerker_loq"
# + missing
# - 1, -2 voor 2 landen 

#data1=merge(sample1,subject1,by="id_subject",all=TRUE)
#data1=merge(data1,subject2,by="id_subject",all=TRUE)
#data1=merge(data1,dataUM,by="id_sample",all=TRUE)
#dim(data1)
#head(data1)
#data1$matrix="UM"


# create a new dataset
size=900
countryName1="C1"
countryName2="C2"
countryName3="C3"
set.seed(1234)
data2=data.frame(id_sample=seq(1,size,1),id_subject=seq(1,size,1))
data2$matrix="UM"
data2$samplingyear=sample(c(2014,2015,2016,2017),size,replace=TRUE)
data2$samplingmonth=sample(seq(1,12,1),size,replace=TRUE)
data2$samplingday=sample(seq(1,28,1),size,replace=TRUE)
data2$sampledate = as.Date(paste(data2$samplingyear,'-',data2$samplingmonth,'-',data2$samplingday,sep=""),"%Y-%m-%d")
data2$sex=sample(c("F","M"),size,replace=TRUE,prob=c(0.6,0.4))
data2$sex=as.factor(data2$sex)
data2$country=sample(c(countryName1,countryName2,countryName3),size,replace=TRUE,prob=c(0.4,0.3,0.3))
data2$ageyears=NaN
data2$ageyears[which(data2$sex=="F")]=sample(seq(20,58,1),length(which(data2$sex=="F")),replace=TRUE)
data2$ageyears[which(data2$sex=="M")]=sample(seq(25,68,1),length(which(data2$sex=="M")),replace=TRUE)
data2$isced=NaN
data2$isced[which(data2$country==countryName1)]=sample(c(1,2,3),length(which(data2$country==countryName1)),replace=TRUE,prob=c(0.2,0.4,0.4))
data2$isced[which(data2$country==countryName2)]=sample(c(1,2,3),length(which(data2$country==countryName2)),replace=TRUE,prob=c(0.3,0.3,0.4))
data2$isced[which(data2$country==countryName3)]=sample(c(1,2,3),length(which(data2$country==countryName3)),replace=TRUE,prob=c(0.4,0.3,0.2))
data2$smoking=NaN
data2$smoking[which(data2$country==countryName1 & data2$sex=="F")]=sample(c(0,1),length(which(data2$country==countryName1 & data2$sex=="F")),replace=TRUE,prob=c(0.8,0.2))
data2$smoking[which(data2$country==countryName2 & data2$sex=="F")]=sample(c(0,1),length(which(data2$country==countryName2 & data2$sex=="F")),replace=TRUE,prob=c(0.7,0.3))
data2$smoking[which(data2$country==countryName3 & data2$sex=="F")]=sample(c(0,1),length(which(data2$country==countryName3 & data2$sex=="F")),replace=TRUE,prob=c(0.8,0.2))
data2$smoking[which(data2$country==countryName1 & data2$sex=="M")]=sample(c(0,1),length(which(data2$country==countryName1 & data2$sex=="M")),replace=TRUE,prob=c(0.7,0.3))
data2$smoking[which(data2$country==countryName2 & data2$sex=="M")]=sample(c(0,1),length(which(data2$country==countryName2 & data2$sex=="M")),replace=TRUE,prob=c(0.6,0.4))
data2$smoking[which(data2$country==countryName3 & data2$sex=="M")]=sample(c(0,1),length(which(data2$country==countryName3 & data2$sex=="M")),replace=TRUE,prob=c(0.6,0.4))
# add some missing values
data2$smoking[which(data2$id_sample %in% sample(data2$id_sample,5,replace=TRUE))]=NaN
data2$height=NaN
data2$height[which(data2$sex=="F")]=round(rnorm(length(which(data2$sex=="F")),168,10)*10)/10
data2$height[which(data2$sex=="M")]=round(rnorm(length(which(data2$sex=="M")),175,10)*10)/10
data2$bmi=NaN
data2$bmi[which(data2$sex=="F")]=round(rnorm(length(which(data2$sex=="F")),23,2.5)*10)/10
data2$bmi[which(data2$sex=="M")]=round(rnorm(length(which(data2$sex=="M")),21,2)*10)/10
# add 50 possible extreme outliers
data2$bmi[which(data2$id_sample %in% as.numeric(sample(seq(1,dim(data2)[1]),50,replace=FALSE)))]=round(rnorm(50,32,2)*10)/10
data2$weight=round(data2$bmi*((data2$height/100)*(data2$height/100))*10)/10
data2$urinary_biomarker_loq=NaN
data2$urinary_biomarker_loq[which(data2$country==countryName1)]=2
data2$urinary_biomarker_loq[which(data2$country==countryName2)]=3
data2$urinary_biomarker_loq[which(data2$country==countryName3)]=4
data2$urinary_biomarker_lod=NaN
data2$urinary_biomarker_lod[which(data2$country==countryName1)]=1
data2$urinary_biomarker_lod[which(data2$country==countryName2)]=1.5
data2$urinary_biomarker_lod[which(data2$country==countryName3)]=2
data2$urinary_biomarker=NaN
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2014)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2014)),2.1,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2015)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2015)),2,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2016)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2016)),1.9,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2017)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="F" & data2$samplingyear==2017)),1.8,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2014)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2014)),1.8,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2015)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2015)),1.7,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2016)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2016)),1.5,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2017)]=round(rnorm(length(which(data2$country==countryName1 & data2$sex=="M" & data2$samplingyear==2017)),1.5,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2014)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2014)),2.1,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2015)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2015)),1.9,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2016)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2016)),1.7,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2017)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="F" & data2$samplingyear==2017)),1.5,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2014)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2014)),1.8,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2015)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2015)),1.7,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2016)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2016)),1.5,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2017)]=round(rnorm(length(which(data2$country==countryName2 & data2$sex=="M" & data2$samplingyear==2017)),1.4,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2014)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2014)),1.9,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2015)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2015)),1.7,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2016)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2016)),1.6,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2017)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="F" & data2$samplingyear==2017)),1.5,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2014)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2014)),1.7,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2015)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2015)),1.6,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2016)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2016)),1.5,1)*10)/10
data2$urinary_biomarker[which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2017)]=round(rnorm(length(which(data2$country==countryName3 & data2$sex=="M" & data2$samplingyear==2017)),1.5,1)*10)/10
# add 50 possible extreme outliers
data2$urinary_biomarker[which(data2$id_sample %in% as.numeric(sample(seq(1,dim(data2)[1]),50,replace=FALSE)))]=round(rnorm(50,5,0.2)*10)/10
# take exp
data2$urinary_biomarker=exp(data2$urinary_biomarker)
# make possible negatives or below loq above loq
data2$urinary_biomarker[which(data2$urinary_biomarker<4)]=data2$urinary_biomarker[which(data2$urinary_biomarker<4)]+2
data2$urinary_biomarker[which(data2$urinary_biomarker<4)]=data2$urinary_biomarker[which(data2$urinary_biomarker<4)]+2
data2$urinary_biomarker[which(data2$urinary_biomarker<4)]=data2$urinary_biomarker[which(data2$urinary_biomarker<4)]+2
data2$urinary_biomarker[which(data2$urinary_biomarker<4)]=-1
# impute some missing values and -1 and -2
data2$urinary_biomarker[which(data2$id_sample %in% as.numeric(sample(seq(1,dim(data2)[1]),30,replace=FALSE)))]=sample(c(NaN,-1,-2),30,replace=TRUE)

write.table(data2,file=paste(inputdir,"data1.csv",sep=""),quote = TRUE, sep =",",dec = ".", row.names = FALSE,col.names=TRUE,qmethod ="double" )
